#include "virables.h"


ConsoleInit::ConsoleInit()
{
    isInitialised=0;
}

ConsoleInit::~ConsoleInit()
{
    if (isInitialised==1) FreeMem();
}


void ConsoleInit::ReadConfig(char *fn) 
{
    FILE *f,*g;
    char tmp[500];
    unsigned int ctemp;
    float ftemp;
    unsigned int i,j;
    
    if (isInitialised==1) FreeMem();
    isInitialised=2;
    f=fopen(fn,"r");
    misc::SkipComment(f);fgets(tmp,500,f);	/* Comment */
    misc::SkipComment(f);
    fscanf(f,"%s",ncfn);		/* Neuron configuration file name */

    g=fopen(ncfn,"r");			/* Getting some information from 
					Network configuration */
    misc::SkipComment(g);
    fscanf(g,"%u",&kNeu);		/* Number of Neurons */
    fgets(tmp,500,g);misc::SkipComment(g);
    fscanf(g,"%u",&kCon);		/* Number of Connections */
    fclose(g);
    
    fgets(tmp,500,f);misc::SkipComment(f);
    fscanf(f,"%s",tfn);			/* Input TEST Data file */
    fgets(tmp,500,f);misc::SkipComment(f);
    fscanf(f,"%s",ofn);
    fgets(tmp,500,f);misc::SkipComment(f);
    fscanf(f,"%s",ctfn);
    fgets(tmp,500,f);misc::SkipComment(f);
    fscanf(f,"%lu", &kIter);	/* Maximal number of iterations */
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%lu", &kID);	/* Number of lines to read from data file */
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%lu",&CVStart);	/* First line for Cross Validation Algorithm */
    if (CVStart) 
    {
	fscanf(f,"%lu",&CVEnd);	/* Last line for CV Algorithm */
	CV=1;
	CVkID=CVEnd-CVStart+1;
	LrnkID=kID-CVkID;
    }
    else CV=0;
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%lu",&kcID);	/* Number of lines to read from control file */
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%u",&MaxNNet); 	/* Maximal number of Neural Networks */
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%u", &kNNet);	/* Number of NNetworks */
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%s",imNNet);	/* Reading NNetworks Initialisation mode */
    if (str::strcmp_(imNNet,"FullRandom")==0)
    {
	imNNet_=0;
	imNNetFn[0]=0;
	imFrom=new BaseFloatType*;
	imFrom[0]=new BaseFloatType;
	imTo=new BaseFloatType*;
	imTo[0]=new BaseFloatType;
	fscanf(f,"%f",&ftemp);imFrom[0][0]=(BaseFloatType)ftemp;
	fscanf(f,"%f",&ftemp);imTo[0][0]=(BaseFloatType)ftemp;
    }
    else if (str::strcmp_(imNNet,"Random")==0)
    {
	imNNet_=1;
	fscanf(f,"%s",imNNetFn);
	imFrom=new BaseFloatType*;
	imFrom[0]=new BaseFloatType[kNeu+kCon];
	imTo=new BaseFloatType*;
	imTo[0]=new BaseFloatType[kNeu+kCon];
	g=fopen(imNNetFn,"r");
	for (i=0;i<kNeu+kCon;i++)
	{
	    fscanf(g,"%f",&ftemp);imFrom[0][i]=(BaseFloatType)ftemp;
	}
        fgets(tmp,500,g);
	for (i=0;i<kNeu+kCon;i++)
	{
	    fscanf(g,"%f",&ftemp);imTo[0][i]=(BaseFloatType)ftemp;
	}
	fclose(g);
    }
    else if (str::strcmp_(imNNet,"Read")==0)
    {
	imNNet_=2;
	fscanf(f,"%s",imNNetFn);
	imFrom=new BaseFloatType*;
	imFrom[0]=new BaseFloatType[kNeu+kCon];
	g=fopen(imNNetFn,"r");
	for (i=0;i<kNeu+kCon;i++)
	{
	    fscanf(g,"%f",&ftemp);imFrom[0][i]=(BaseFloatType)ftemp;
	}
	fclose(g);
    }
    else if (str::strcmp_(imNNet,"DifFullRandom")==0)
    {
	imNNet_=3;
	imNNetFn[0]=0;
	imFrom=new BaseFloatType*;
	imFrom[0]=new BaseFloatType[kNNet];
	imTo=new BaseFloatType*;
	imTo[0]=new BaseFloatType[kNNet];
	for (i=0;i<kNNet;i++)
	{
	    fscanf(f,"%f",&ftemp);imFrom[0][i]=(BaseFloatType)ftemp;
	    fscanf(f,"%f",&ftemp);imTo[0][i]=(BaseFloatType)ftemp;
	}
    }
    else if (str::strcmp_(imNNet,"DifRandom")==0)
    {
	imNNet_=4;
	imFrom=new BaseFloatType*[kNNet];
	imTo=new BaseFloatType*[kNNet];
	fscanf(f,"%s",imNNetFn);
	g=fopen(imNNetFn,"r");
	for (i=0;i<kNNet;i++)
	{
	    imFrom[i]=new BaseFloatType[kNeu+kCon];
	    imTo[i]=new BaseFloatType[kNeu+kCon];
	    for (j=0;j<kNeu+kCon;j++)
	    {
		fscanf(g,"%f",&ftemp);imFrom[i][j]=(BaseFloatType)ftemp;
	    }
	    fgets(tmp,500,g);
	    for (j=0;j<kNeu+kCon;j++)
	    {
		fscanf(g,"%f",&ftemp);imTo[i][j]=(BaseFloatType)ftemp;
	    }
	    fgets(tmp,500,g);
	}
	fclose(g);
    }
    else if (str::strcmp_(imNNet,"DifRead")==0)
    {
	imNNet_=5;
	imFrom=new BaseFloatType*[kNNet];
	fscanf(f,"%s",imNNetFn);
	g=fopen(imNNetFn,"r");
	for (i=0;i<kNNet;i++)
	{
	    imFrom[i]=new BaseFloatType[kNeu+kCon];
	    for (j=0;j<kNeu+kCon;j++)
	    {
		fscanf(g,"%f",&ftemp);imFrom[i][j]=(BaseFloatType)ftemp;
	    }
	    fgets(tmp,500,g);
	}
	fclose(g);
    }

    fgets(tmp,500,f);misc::SkipComment(f);
    fscanf(f,"%s",Qi);
    fgets(tmp,500,f);misc::SkipComment(f);
    fscanf(f,"%s",Qa);
    fgets(tmp,500,f);misc::SkipComment(f);
    
    fscanf(f,"%f", &pnNNet);	/* Percentes to produce */
		    /* Reading producing methods */
    fgets(tmp,500,f); misc::SkipComment(f);	/* Randomiz Parametrs */
    fscanf(f,"%u",&RndWeight); 
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%u",&RndMin); 
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%u",&RndMax); 
    fgets(tmp,500,f); misc::SkipComment(f);	/* Corelate Parametrs */
    fscanf(f,"%u",&CrlWeight); 
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%u",&CrlMin); 
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%u",&CrlMax); 
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%f",&ftemp); CrlUp=(BaseFloatType)ftemp;
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%f",&ftemp); pCrl=(BaseFloatType)ftemp;	/* Corelate Pics */
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%f",&ftemp); pCrlUp=(BaseFloatType)ftemp;
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%f",&ftemp); spCrl=(BaseFloatType)ftemp; /* Corelate Single Pics */
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%f",&ftemp); spCrlUp=(BaseFloatType)ftemp;
    fgets(tmp,500,f); misc::SkipComment(f);			/* Combine Parametrs */
    fscanf(f,"%u",&CmbWeight); 
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%u",&CmbMin); 
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%u",&CmbMax); 
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%u",&ctemp);AdvNeu=(unsigned char)ctemp;
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%s",tmp);
    if (str::strcmp_(tmp,"TakeBest")==0)
	gbMet=0;
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%f",&ftemp); nDist=(BaseFloatType)ftemp;
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%f",&ftemp); nnDist=(BaseFloatType)ftemp;
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%f",&ftemp); pnDist=(BaseFloatType)ftemp;
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%f",&ftemp); nStay=(BaseFloatType)ftemp;
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%u",&oDelete);
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%u",&ooStay);
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%f",&ftemp); oStay=(BaseFloatType)ftemp;
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%u",&kDisable);
    fgets(tmp,500,f); misc::SkipComment(f);
    Disable=new unsigned char[kDisable];
    for (i=0;i<kDisable;i++)
    {
	fscanf(f,"%u",&ctemp);
	Disable[i]=(unsigned char)ctemp;
    }
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%lu",&step);
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%u",&DisplayEvents);
    fgets(tmp,500,f); misc::SkipComment(f);
    fscanf(f,"%u",&ctemp); ShowBests=(unsigned char)ctemp;
    
    fclose(f);
    
    isInitialised=1;
}


void ConsoleInit::FreeMem()
{
    unsigned int i;

    isInitialised=3;    
    delete Disable;
    
    delete imFrom[0];
    if ((imNNet_==4)||(imNNet_==5))	// DifRandom, DifRead
    {
	for (i=1;i<kNNet;i++)
	    delete imFrom[i];
    }
    delete imFrom;
    if ((imNNet_!=2)&&(imNNet_!=5))	// !Read !DifRead
    {
	delete imTo[0];
	if (imNNet_==4)			// DifRandom
	{
		for (i=1;i<kNNet;i++)
    		    delete imTo[i];
	}
        delete imTo;
    }
    isInitialised=0;
}


void ConsoleInit::FastConfig()
{
    FILE *f;
    char tmp[500];
    
    f=fopen("fast.opt","r");
    fscanf(f,"%u",&OnlyCalc); fgets(tmp,500,f);
    fscanf(f,"%s",LoadFn); /* fgets(tmp,500,f); */
    if ((LoadFn[0]=='0')&&(LoadFn[1]==0)) LoadFn[0]=0;
    fclose(f);
}
    
